Bug 772777 - pre compile and normalize search filter
Summary: pre compile and normalize search filter
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: 389-ds-base
Version: 6.3
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: rc
: ---
Assignee: Rich Megginson
QA Contact: IDM QE LIST
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2012-01-09 23:07 UTC by Rich Megginson
Modified: 2012-06-20 07:11 UTC (History)
2 users (show)

Fixed In Version: 389-ds-base-1.2.10.0-1.el6
Doc Type: Bug Fix
Doc Text:
Cause: Using search filters with many substring filters and attributes that require a lot of normalization (such as DN syntax value). Consequence: Poor performance due to excessive normalization and regex compilation. Change: The code will now pre-compile and pre-normalize such search filters. Result: Better performance for search filters with many substring filters and attributes that require a lot of normalization.
Clone Of:
Environment:
Last Closed: 2012-06-20 07:11:47 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2012:0813 normal SHIPPED_LIVE Low: 389-ds-base security, bug fix, and enhancement update 2012-06-19 19:29:15 UTC

Description Rich Megginson 2012-01-09 23:07:39 UTC
This bug is created as a clone of upstream ticket:
https://fedorahosted.org/389/ticket/1

When processing large search filters which are applied to every entry in the search result set, the filter is normalized anew each time a new entry is tested.  For substring filters, a regular expression must be created, compiled, and freed each time the substring filter is tested, in addition to normalizing the values.  For example, if the search filter contains 1000 substring sub-filters, for each entry tested with the filter, this will require 1000 filter normalizations followed by 1000 regex creation, compilation, and cleanup.  If there are 1000 entries in the search result set, this will require a million such operations.

Comment 1 Jenny Severance 2012-01-13 18:04:34 UTC
please add steps to reproduce/verify this issue
Thanks

Comment 3 Rich Megginson 2012-04-17 20:13:50 UTC
svn ci -m "added tests for Bug 772777 - pre compile and normalize search filter" data/DS/6.0/filter/en/bigdneq.filt data/DS/6.0/filter/en/bigdnsub.filt data/DS/6.0/filter/en/filters.ldif testcases/DS/6.0/filter/tet_scen.sh testcases/DS/6.0/filter/filter.sh
Adding         data/DS/6.0/filter/en/bigdneq.filt
Adding         data/DS/6.0/filter/en/bigdnsub.filt
Sending        data/DS/6.0/filter/en/filters.ldif
Sending        testcases/DS/6.0/filter/filter.sh
Sending        testcases/DS/6.0/filter/tet_scen.sh
Transmitting file data .....
Committed revision 6471.

RHEL6.3 branch

Comment 4 Amita Sharma 2012-04-24 06:55:59 UTC
Filter test suit is passing 100%, hence marking this bug as VERIFIED.

Comment 5 Rich Megginson 2012-05-24 22:31:29 UTC
    Technical note added. If any revisions are required, please edit the "Technical Notes" field
    accordingly. All revisions will be proofread by the Engineering Content Services team.
    
    New Contents:
Cause: Using search filters with many substring filters and attributes that require a lot of normalization (such as DN syntax value).
Consequence: Poor performance due to excessive normalization and regex compilation.
Change: The code will now pre-compile and pre-normalize such search filters.
Result: Better performance for search filters with many substring filters and attributes that require a lot of normalization.

Comment 6 errata-xmlrpc 2012-06-20 07:11:47 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHSA-2012-0813.html


Note You need to log in before you can comment on or make changes to this bug.